# Create a release pipeline

POST https://app.launchdarkly.com/api/v2/projects/{projectKey}/release-pipelines
Content-Type: application/json

Creates a new release pipeline.

The first release pipeline you create is automatically set as the default release pipeline for your project. To change the default release pipeline, use the [Update project](https://launchdarkly.com/docs/api/projects/patch-project) API to set the `defaultReleasePipelineKey`.

You can create up to 20 release pipelines per project.


Reference: https://launchdarkly.com/docs/api/release-pipelines-beta/post-release-pipeline

## OpenAPI Specification

```yaml
openapi: 3.1.0
info:
  title: LaunchDarkly REST API
  version: 1.0.0
paths:
  /api/v2/projects/{projectKey}/release-pipelines:
    post:
      operationId: post-release-pipeline
      summary: Create a release pipeline
      description: >
        Creates a new release pipeline.


        The first release pipeline you create is automatically set as the
        default release pipeline for your project. To change the default release
        pipeline, use the [Update
        project](https://launchdarkly.com/docs/api/projects/patch-project) API
        to set the `defaultReleasePipelineKey`.


        You can create up to 20 release pipelines per project.
      tags:
        - subpackage_releasePipelinesBeta
      parameters:
        - name: projectKey
          in: path
          description: The project key
          required: true
          schema:
            type: string
            format: string
        - name: Authorization
          in: header
          required: true
          schema:
            type: string
      responses:
        '201':
          description: Release pipeline response
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ReleasePipeline'
        '400':
          description: Invalid request
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/InvalidRequestErrorRep'
        '403':
          description: Forbidden
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ForbiddenErrorRep'
        '404':
          description: Invalid resource identifier
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/NotFoundErrorRep'
        '409':
          description: Status conflict
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/StatusConflictErrorRep'
      requestBody:
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/CreateReleasePipelineInput'
servers:
  - url: https://app.launchdarkly.com
  - url: https://app.launchdarkly.us
components:
  schemas:
    ReleaseStrategy:
      type: string
      title: ReleaseStrategy
    ReleaseGuardianConfiguration:
      type: object
      properties:
        monitoringWindowMilliseconds:
          type: integer
          format: int64
          description: The monitoring window in milliseconds
        rolloutWeight:
          type: integer
          description: The rollout weight percentage
        rollbackOnRegression:
          type: boolean
          description: Whether or not to roll back on regression
        randomizationUnit:
          type: string
          description: The randomization unit for the measured rollout
      required:
        - monitoringWindowMilliseconds
        - rolloutWeight
        - rollbackOnRegression
      title: ReleaseGuardianConfiguration
    AudienceConfiguration:
      type: object
      properties:
        releaseStrategy:
          $ref: '#/components/schemas/ReleaseStrategy'
          description: The release strategy
        requireApproval:
          type: boolean
          description: Whether or not the audience requires approval
        notifyMemberIds:
          type: array
          items:
            type: string
          description: >-
            An array of member IDs. These members are notified to review the
            approval request.
        notifyTeamKeys:
          type: array
          items:
            type: string
          description: >-
            An array of team keys. The members of these teams are notified to
            review the approval request.
        releaseGuardianConfiguration:
          $ref: '#/components/schemas/ReleaseGuardianConfiguration'
          description: The configuration for the release guardian.
      required:
        - releaseStrategy
        - requireApproval
      title: AudienceConfiguration
    AudiencePost:
      type: object
      properties:
        environmentKey:
          type: string
          description: A project-unique key for the environment.
        name:
          type: string
          description: The audience name
        segmentKeys:
          type: array
          items:
            type: string
          description: Segments targeted by this audience.
        configuration:
          $ref: '#/components/schemas/AudienceConfiguration'
          description: The configuration for the audience's rollout.
      required:
        - environmentKey
        - name
      title: AudiencePost
    PhaseConfiguration:
      type: object
      properties: {}
      title: PhaseConfiguration
    CreatePhaseInput:
      type: object
      properties:
        audiences:
          type: array
          items:
            $ref: '#/components/schemas/AudiencePost'
          description: >-
            An ordered list of the audiences for this release phase. Each
            audience corresponds to a LaunchDarkly environment.
        name:
          type: string
          description: The release phase name
        configuration:
          $ref: '#/components/schemas/PhaseConfiguration'
          description: The configuration for the phase's rollout.
      required:
        - audiences
        - name
      title: CreatePhaseInput
    CreateReleasePipelineInput:
      type: object
      properties:
        description:
          type: string
          description: The release pipeline description
        key:
          type: string
          description: The unique identifier of this release pipeline
        name:
          type: string
          description: The name of the release pipeline
        phases:
          type: array
          items:
            $ref: '#/components/schemas/CreatePhaseInput'
          description: >-
            A logical grouping of one or more environments that share attributes
            for rolling out changes
        tags:
          type: array
          items:
            type: string
          description: A list of tags for this release pipeline
        isProjectDefault:
          type: boolean
          description: >-
            Whether or not the newly created pipeline should be set as the
            default pipeline for this project
        isLegacy:
          type: boolean
          description: Whether or not the pipeline is enabled for Release Automation.
      required:
        - key
        - name
        - phases
      title: CreateReleasePipelineInput
    Link:
      type: object
      properties:
        href:
          type: string
          description: The URL of the link
        type:
          type: string
          description: The type of the link
      title: Link
    EnvironmentSummary:
      type: object
      properties:
        _links:
          type: object
          additionalProperties:
            $ref: '#/components/schemas/Link'
          description: The location and content type of related resources
        key:
          type: string
          description: A project-unique key for the environment
        name:
          type: string
          description: A human-friendly name for the environment
        color:
          type: string
          description: The color used to indicate this environment in the UI
      required:
        - _links
        - key
        - name
        - color
      title: EnvironmentSummary
    Audience:
      type: object
      properties:
        environment:
          $ref: '#/components/schemas/EnvironmentSummary'
          description: >-
            Details about the environment. When the environment has been
            deleted, this field is omitted.
        name:
          type: string
          description: The release phase name
        configuration:
          $ref: '#/components/schemas/AudienceConfiguration'
          description: The configuration for the audience's rollout.
        segmentKeys:
          type: array
          items:
            type: string
          description: A list of segment keys
      required:
        - name
      title: Audience
    Audiences:
      type: array
      items:
        $ref: '#/components/schemas/Audience'
      title: Audiences
    Phase:
      type: object
      properties:
        id:
          type: string
          description: The phase ID
        audiences:
          $ref: '#/components/schemas/Audiences'
          description: >-
            An ordered list of the audiences for this release phase. Each
            audience corresponds to a LaunchDarkly environment.
        name:
          type: string
          description: The release phase name
        configuration:
          $ref: '#/components/schemas/PhaseConfiguration'
          description: The configuration for the phase's rollout.
      required:
        - id
        - audiences
        - name
      title: Phase
    ActionIdentifier:
      type: string
      title: ActionIdentifier
    ActionSpecifier:
      type: string
      title: ActionSpecifier
    AccessDeniedReasonEffect:
      type: string
      enum:
        - allow
        - deny
      description: Whether this statement should allow or deny actions on the resources.
      title: AccessDeniedReasonEffect
    AccessDeniedReason:
      type: object
      properties:
        resources:
          type: array
          items:
            type: string
          description: Resource specifier strings
        notResources:
          type: array
          items:
            type: string
          description: >-
            Targeted resources are the resources NOT in this list. The
            <code>resources</code> and <code>notActions</code> fields must be
            empty to use this field.
        actions:
          type: array
          items:
            $ref: '#/components/schemas/ActionSpecifier'
          description: Actions to perform on a resource
        notActions:
          type: array
          items:
            $ref: '#/components/schemas/ActionSpecifier'
          description: >-
            Targeted actions are the actions NOT in this list. The
            <code>actions</code> and <code>notResources</code> fields must be
            empty to use this field.
        effect:
          $ref: '#/components/schemas/AccessDeniedReasonEffect'
          description: >-
            Whether this statement should allow or deny actions on the
            resources.
        role_name:
          type: string
      required:
        - effect
      title: AccessDeniedReason
    AccessDenied:
      type: object
      properties:
        action:
          $ref: '#/components/schemas/ActionIdentifier'
        reason:
          $ref: '#/components/schemas/AccessDeniedReason'
      required:
        - action
        - reason
      title: AccessDenied
    AccessAllowedReasonEffect:
      type: string
      enum:
        - allow
        - deny
      description: Whether this statement should allow or deny actions on the resources.
      title: AccessAllowedReasonEffect
    AccessAllowedReason:
      type: object
      properties:
        resources:
          type: array
          items:
            type: string
          description: Resource specifier strings
        notResources:
          type: array
          items:
            type: string
          description: >-
            Targeted resources are the resources NOT in this list. The
            <code>resources</code> and <code>notActions</code> fields must be
            empty to use this field.
        actions:
          type: array
          items:
            $ref: '#/components/schemas/ActionSpecifier'
          description: Actions to perform on a resource
        notActions:
          type: array
          items:
            $ref: '#/components/schemas/ActionSpecifier'
          description: >-
            Targeted actions are the actions NOT in this list. The
            <code>actions</code> and <code>notResources</code> fields must be
            empty to use this field.
        effect:
          $ref: '#/components/schemas/AccessAllowedReasonEffect'
          description: >-
            Whether this statement should allow or deny actions on the
            resources.
        role_name:
          type: string
      required:
        - effect
      title: AccessAllowedReason
    AccessAllowedRep:
      type: object
      properties:
        action:
          $ref: '#/components/schemas/ActionIdentifier'
        reason:
          $ref: '#/components/schemas/AccessAllowedReason'
      required:
        - action
        - reason
      title: AccessAllowedRep
    Access:
      type: object
      properties:
        denied:
          type: array
          items:
            $ref: '#/components/schemas/AccessDenied'
        allowed:
          type: array
          items:
            $ref: '#/components/schemas/AccessAllowedRep'
      required:
        - denied
        - allowed
      title: Access
    ReleasePipeline:
      type: object
      properties:
        createdAt:
          type: string
          format: date-time
          description: Timestamp of when the release pipeline was created
        description:
          type: string
          description: The release pipeline description
        key:
          type: string
          description: The release pipeline key
        name:
          type: string
          description: The release pipeline name
        phases:
          type: array
          items:
            $ref: '#/components/schemas/Phase'
          description: >-
            An ordered list of the release pipeline phases. Each phase is a
            logical grouping of one or more environments that share attributes
            for rolling out changes.
        tags:
          type: array
          items:
            type: string
          description: A list of the release pipeline's tags
        _version:
          type: integer
          description: The release pipeline version
        _access:
          $ref: '#/components/schemas/Access'
          description: Details on the allowed and denied actions for this release pipeline
        isProjectDefault:
          type: boolean
          description: >-
            Whether this release pipeline is the default pipeline for the
            project
        _isLegacy:
          type: boolean
          description: Whether this release pipeline is a legacy pipeline
      required:
        - createdAt
        - key
        - name
        - phases
      title: ReleasePipeline
    InvalidRequestErrorRep:
      type: object
      properties:
        code:
          type: string
          description: Specific error code encountered
        message:
          type: string
          description: Description of the error
      required:
        - code
        - message
      title: InvalidRequestErrorRep
    ForbiddenErrorRep:
      type: object
      properties:
        code:
          type: string
          description: Specific error code encountered
        message:
          type: string
          description: Description of the error
      required:
        - code
        - message
      title: ForbiddenErrorRep
    NotFoundErrorRep:
      type: object
      properties:
        code:
          type: string
          description: Specific error code encountered
        message:
          type: string
          description: Description of the error
      required:
        - code
        - message
      title: NotFoundErrorRep
    StatusConflictErrorRep:
      type: object
      properties:
        code:
          type: string
          description: Specific error code encountered
        message:
          type: string
          description: Description of the error
      required:
        - code
        - message
      title: StatusConflictErrorRep
  securitySchemes:
    ApiKey:
      type: apiKey
      in: header
      name: Authorization

```

## SDK Code Examples

```python
import requests

url = "https://app.launchdarkly.com/api/v2/projects/projectKey/release-pipelines"

payload = {
    "key": "standard-pipeline",
    "name": "Standard Pipeline",
    "phases": [
        {
            "audiences": [
                {
                    "environmentKey": "string",
                    "name": "string"
                }
            ],
            "name": "Phase 1 - Testing"
        }
    ]
}
headers = {
    "Authorization": "<apiKey>",
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers)

print(response.json())
```

```javascript
const url = 'https://app.launchdarkly.com/api/v2/projects/projectKey/release-pipelines';
const options = {
  method: 'POST',
  headers: {Authorization: '<apiKey>', 'Content-Type': 'application/json'},
  body: '{"key":"standard-pipeline","name":"Standard Pipeline","phases":[{"audiences":[{"environmentKey":"string","name":"string"}],"name":"Phase 1 - Testing"}]}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://app.launchdarkly.com/api/v2/projects/projectKey/release-pipelines"

	payload := strings.NewReader("{\n  \"key\": \"standard-pipeline\",\n  \"name\": \"Standard Pipeline\",\n  \"phases\": [\n    {\n      \"audiences\": [\n        {\n          \"environmentKey\": \"string\",\n          \"name\": \"string\"\n        }\n      ],\n      \"name\": \"Phase 1 - Testing\"\n    }\n  ]\n}")

	req, _ := http.NewRequest("POST", url, payload)

	req.Header.Add("Authorization", "<apiKey>")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://app.launchdarkly.com/api/v2/projects/projectKey/release-pipelines")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["Authorization"] = '<apiKey>'
request["Content-Type"] = 'application/json'
request.body = "{\n  \"key\": \"standard-pipeline\",\n  \"name\": \"Standard Pipeline\",\n  \"phases\": [\n    {\n      \"audiences\": [\n        {\n          \"environmentKey\": \"string\",\n          \"name\": \"string\"\n        }\n      ],\n      \"name\": \"Phase 1 - Testing\"\n    }\n  ]\n}"

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.post("https://app.launchdarkly.com/api/v2/projects/projectKey/release-pipelines")
  .header("Authorization", "<apiKey>")
  .header("Content-Type", "application/json")
  .body("{\n  \"key\": \"standard-pipeline\",\n  \"name\": \"Standard Pipeline\",\n  \"phases\": [\n    {\n      \"audiences\": [\n        {\n          \"environmentKey\": \"string\",\n          \"name\": \"string\"\n        }\n      ],\n      \"name\": \"Phase 1 - Testing\"\n    }\n  ]\n}")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('POST', 'https://app.launchdarkly.com/api/v2/projects/projectKey/release-pipelines', [
  'body' => '{
  "key": "standard-pipeline",
  "name": "Standard Pipeline",
  "phases": [
    {
      "audiences": [
        {
          "environmentKey": "string",
          "name": "string"
        }
      ],
      "name": "Phase 1 - Testing"
    }
  ]
}',
  'headers' => [
    'Authorization' => '<apiKey>',
    'Content-Type' => 'application/json',
  ],
]);

echo $response->getBody();
```

```csharp
using RestSharp;

var client = new RestClient("https://app.launchdarkly.com/api/v2/projects/projectKey/release-pipelines");
var request = new RestRequest(Method.POST);
request.AddHeader("Authorization", "<apiKey>");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{\n  \"key\": \"standard-pipeline\",\n  \"name\": \"Standard Pipeline\",\n  \"phases\": [\n    {\n      \"audiences\": [\n        {\n          \"environmentKey\": \"string\",\n          \"name\": \"string\"\n        }\n      ],\n      \"name\": \"Phase 1 - Testing\"\n    }\n  ]\n}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let headers = [
  "Authorization": "<apiKey>",
  "Content-Type": "application/json"
]
let parameters = [
  "key": "standard-pipeline",
  "name": "Standard Pipeline",
  "phases": [
    [
      "audiences": [
        [
          "environmentKey": "string",
          "name": "string"
        ]
      ],
      "name": "Phase 1 - Testing"
    ]
  ]
] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://app.launchdarkly.com/api/v2/projects/projectKey/release-pipelines")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "POST"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```